CREATE TABLE asm_role_memberships (
    ROLE_MEMBERSHIP_ID       NUMBER(18, 0),
    PARENT_ENT_ROLE_ID       NUMBER(18, 0),
    PARENT_ROLE_ID           NUMBER(18, 0),
    PARENT_ROLE_TYPE         VARCHAR2(320)    NOT NULL,
    CHILD_ROLE_ID            NUMBER(18, 0),
    CHILD_ENT_ROLE_ID        NUMBER(18, 0),
    CHILD_ROLE_TYPE          VARCHAR2(320)    NOT NULL,
    MODULE_ID                VARCHAR2(128),
    APPLICATION_ID           NUMBER(18, 0),
    ENTERPRISE_ID            NUMBER(18, 0)    NOT NULL,
    OBJECT_VERSION_NUMBER    NUMBER(9, 0)     NOT NULL,
    CREATED_BY               VARCHAR2(256)    NOT NULL,
    CREATION_DATE            TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY          VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_DATE         TIMESTAMP(6)     NOT NULL,
    LAST_UPDATE_LOGIN        VARCHAR2(128),
    ROLE_MEMBERSHIP_ID       NUMBER(18, 0),
    PARENT_ENT_ROLE_ID       NUMBER(18, 0),
    PARENT_ROLE_ID           NUMBER(18, 0),
    PARENT_ROLE_TYPE         VARCHAR2(320)    NOT NULL,
    CHILD_ROLE_ID            NUMBER(18, 0),
    CHILD_ENT_ROLE_ID        NUMBER(18, 0),
    CHILD_ROLE_TYPE          VARCHAR2(320)    NOT NULL,
    MODULE_ID                VARCHAR2(128),
    APPLICATION_ID           NUMBER(18, 0),
    ENTERPRISE_ID            NUMBER(18, 0)    NOT NULL,
    OBJECT_VERSION_NUMBER    NUMBER(9, 0)     NOT NULL,
    CREATED_BY               VARCHAR2(256)    NOT NULL,
    CREATION_DATE            TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY          VARCHAR2(256)    NOT NULL,
    LAST_UPDATE_DATE         TIMESTAMP(6)     NOT NULL,
    LAST_UPDATE_LOGIN        VARCHAR2(128),
    CONSTRAINT pk_asm_role_memberships PRIMARY KEY (ROLE_MEMBERSHIP_ID, ROLE_MEMBERSHIP_ID)
);
